/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is bookmarktools.
 *
 * The Initial Developer of the Original Code is
 * Maik Gollnick <maik.gollnick@gmx.de>.
 * Portions created by the Initial Developer are Copyright (C) 2008
 * the Initial Developer. All Rights Reserved.
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */


function InstallRDF(){

	var rdfService = Components.classes["@mozilla.org/rdf/rdf-service;1"].
	                   getService(Components.interfaces.nsIRDFService);

	this.isParsed = false;

	var res_version 		= rdfService.GetResource("http://www.mozilla.org/2004/em-rdf#version");
	var res_name 			= rdfService.GetResource("http://www.mozilla.org/2004/em-rdf#name");
	var res_description 	= rdfService.GetResource("http://www.mozilla.org/2004/em-rdf#description");
	var res_creator	 		= rdfService.GetResource("http://www.mozilla.org/2004/em-rdf#creator");
	var res_homepageURL 	= rdfService.GetResource("http://www.mozilla.org/2004/em-rdf#homepageURL");

	var rdfLiteral = Components.interfaces.nsIRDFLiteral;

	var version;
	var name;
	var description;
	var creator;
	var homepageURL;

	this.parse = function(id){
		var em = Components.classes["@mozilla.org/extensions/manager;1"].
				 getService(Components.interfaces.nsIExtensionManager);

		var file = em.getInstallLocation(id).getItemFile(id, "install.rdf");

		var p = "file:///" + file.path.replace(/\\/g, "/");
		var fileDS = rdfService.GetDataSourceBlocking(p);

		var e = fileDS.GetAllResources();
		while(e.hasMoreElements()) {
	    	var r =  e.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
			if(r.Value == "urn:mozilla:install-manifest"){

				var t0 = fileDS.GetTarget(r, res_version, true);
				var t1 = fileDS.GetTarget(r, res_name, true);
				var t2 = fileDS.GetTarget(r, res_description, true);
				var t3 = fileDS.GetTarget(r, res_creator, true);
				var t4 = fileDS.GetTarget(r, res_homepageURL, true);

				if(t0) version = " v." + t0.QueryInterface(rdfLiteral).Value;
				if(t1) name = t1.QueryInterface(rdfLiteral).Value;
				if(t2) description = t2.QueryInterface(rdfLiteral).Value;
				if(t3) creator = t3.QueryInterface(rdfLiteral).Value;
				if(t4) homepageURL = t4.QueryInterface(rdfLiteral).Value;
			}
		}

		this.isParsed = true;
	};

	this.getVersion = function(){
		if(this.isParsed){
			return version;
		}

		alert("Error: Can't read rdf file!");
		return null;
	};

	this.getApplicationName = function(){
		if(this.isParsed){
			return name;
		}

		alert("Error: Can't read rdf file!");
		return null;
	};

	this.getDescription = function(){
		if(this.isParsed){
			return description;
		}

		alert("Error: Can't read rdf file!");
		return null;
	};

	this.getDeveloper = function(){
		if(this.isParsed){
			return creator;
		}

		alert("Error: Can't read rdf file!");
		return null;
	};

	this.getHomepage = function(){
		if(this.isParsed){
			return homepageURL;
		}

		alert("Error: Can't read rdf file!");
		return null;
	};

}
